GNU bug report logs - #30578
26.0; Dired: moving current directory (./)

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: Drew Adams <drew.adams@HIDDEN>; Keywords: confirmed; merged with #21537, #52004; dated Thu, 22 Feb 2018 17:39:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Forcibly Merged 21537 30578 52004. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Merged 21537 30578. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 30578 <at> debbugs.gnu.org:


Received: (at 30578) by debbugs.gnu.org; 14 Jul 2019 15:15:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 14 11:15:03 2019
Received: from localhost ([127.0.0.1]:45661 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmgDO-0005xE-IQ
	for submit <at> debbugs.gnu.org; Sun, 14 Jul 2019 11:15:03 -0400
Received: from userp2120.oracle.com ([156.151.31.85]:48272)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1hmgDM-0005we-UX
 for 30578 <at> debbugs.gnu.org; Sun, 14 Jul 2019 11:15:01 -0400
Received: from pps.filterd (userp2120.oracle.com [127.0.0.1])
 by userp2120.oracle.com (8.16.0.27/8.16.0.27) with SMTP id x6EFEt4u184031;
 Sun, 14 Jul 2019 15:14:55 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : cc : subject : references :
 in-reply-to : content-type : content-transfer-encoding; s=corp-2018-07-02;
 bh=zD2zJsZF4JysTMyJk4ivvNjj13sCKh+VgTXAIJrGf1s=;
 b=fLWf9bSNxiv8aNcMMq9XHuEBfs1yysolFaswjUJpOrqTxtNOHEepMcUaN/qZyN5a6V0y
 GbGFyqcmnlYowy+XlfGS9lUZpfZTc2qVYTE2SE2ET0eDq95IB0DtaGzrmZpWmYKcN3P7
 TFdEsIICMGwW7VVTgMEWmM3QnvY2FZRsltNfd10pW2+LP4TuC0oeC5V89lqm+C9Hpj70
 k2ANj7/UEL6PBKO3PgeqZG2w6KnyIrLUKiTX1mZGaxACJjV70mtJ/BzKOEYiNDxUM2We
 fU88N7M1/rAmxVZrOGWXK2DcDFlqWks5TTUHQaBtwjb/W7/LcUVPZe6m3jAeAcLyD+6A Bg== 
Received: from userp3020.oracle.com (userp3020.oracle.com [156.151.31.79])
 by userp2120.oracle.com with ESMTP id 2tq7xqk0dr-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Sun, 14 Jul 2019 15:14:55 +0000
Received: from pps.filterd (userp3020.oracle.com [127.0.0.1])
 by userp3020.oracle.com (8.16.0.27/8.16.0.27) with SMTP id x6EFCbmg120789;
 Sun, 14 Jul 2019 15:14:54 GMT
Received: from aserv0121.oracle.com (aserv0121.oracle.com [141.146.126.235])
 by userp3020.oracle.com with ESMTP id 2tq6mkxgkh-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Sun, 14 Jul 2019 15:14:54 +0000
Received: from abhmp0020.oracle.com (abhmp0020.oracle.com [141.146.116.26])
 by aserv0121.oracle.com (8.14.4/8.13.8) with ESMTP id x6EFEoqq008296;
 Sun, 14 Jul 2019 15:14:53 GMT
MIME-Version: 1.0
Message-ID: <076b7394-4370-4701-b4a9-1cb3c7fe37e8@default>
Date: Sun, 14 Jul 2019 08:14:49 -0700 (PDT)
From: Drew Adams <drew.adams@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: RE: bug#30578: 26.0; Dired: moving current directory (./)
References: <8629c371-1006-48af-a91f-e147b792abba@default>
 <87ims4znln.fsf@HIDDEN>
In-Reply-To: <87ims4znln.fsf@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4861.0 (x86)]
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9318
 signatures=668688
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 suspectscore=0
 malwarescore=0
 phishscore=0 bulkscore=0 spamscore=0 mlxscore=0 mlxlogscore=851
 adultscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.0.1-1810050000 definitions=main-1907140189
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9318
 signatures=668688
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0
 priorityscore=1501 malwarescore=0
 suspectscore=0 phishscore=0 bulkscore=0 spamscore=0 clxscore=1011
 lowpriorityscore=0 mlxscore=0 impostorscore=0 mlxlogscore=918 adultscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.0.1-1810050000
 definitions=main-1907140190
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 30578
Cc: 30578 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> I guess it should point the current directory to the new
> location?  But keep all the contents in the buffer (you
> may have marked files and the like)?

Yes.  It should do (the equivalent of) a `mv`
on the current directory.  And the Dired buffer
should then be refreshed using the new location.

And yes, it should ideally keep all settings:
omitted files, markings, whether details are
hidden - everything.  The only thing that
changes is the location of the directory.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#30578; Package emacs. Full text available.

Message received at 30578 <at> debbugs.gnu.org:


Received: (at 30578) by debbugs.gnu.org; 14 Jul 2019 14:40:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 14 10:40:13 2019
Received: from localhost ([127.0.0.1]:45607 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hmffh-0002ux-6r
	for submit <at> debbugs.gnu.org; Sun, 14 Jul 2019 10:40:13 -0400
Received: from quimby.gnus.org ([80.91.231.51]:53244)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1hmffe-0002uj-81
 for 30578 <at> debbugs.gnu.org; Sun, 14 Jul 2019 10:40:10 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1hmffZ-0003CU-Al; Sun, 14 Jul 2019 16:40:07 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Drew Adams <drew.adams@HIDDEN>
Subject: Re: bug#30578: 26.0; Dired: moving current directory (./)
References: <8629c371-1006-48af-a91f-e147b792abba@default>
Date: Sun, 14 Jul 2019 16:40:04 +0200
In-Reply-To: <8629c371-1006-48af-a91f-e147b792abba@default> (Drew Adams's
 message of "Thu, 22 Feb 2018 09:38:17 -0800 (PST)")
Message-ID: <87ims4znln.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Drew Adams <drew.adams@HIDDEN> writes: > See
 https://emacs.stackexchange.com/a/39010/105.
 > > Putting point on the current-directory line of a Dired listing, i.e.,
 > `.', and using `R' to move/rename that directory, works, but you get an
 > [...] Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 30578
Cc: 30578 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Drew Adams <drew.adams@HIDDEN> writes:

> See https://emacs.stackexchange.com/a/39010/105.
>
> Putting point on the current-directory line of a Dired listing, i.e.,
> `.', and using `R' to move/rename that directory, works, but you get an
> error message, and you don't end up in a Dired listing for that
> (now-renamed) directory.
>
> This is the error message you get, where /some/dir1/dir2/ccc/ is the
> directory listed in Dired, i.e., the dir that corresponds to `.' in the
> Dired listing:
>
> Expected to find /some/dir1/dir2/ccc/./ in headerline of
> /some/dir1/dir2/ccc/

This seems to be still present on the Emacs trunk, and here's the
backtrace (which you should include in bug reports like this).

If I understand the code correctly, it simply doesn't understand that
"." is the directory itself, and treats it as any subdirectory: It
removes the line with "." from the buffer and then wants to adjust the
header line.

Instead, I guess it should...  point the current directory to the new
location?  But keep all the contents in the buffer (you may have marked
files and the like)?

Alternatively, for a really easy fix, it could just error out
immediately when you try this.  :-/

Debugger entered--Lisp error: (error "Expected to find =E2=80=98/tmp/foo1/.=
/=E2=80=99 in headerline of /tmp/foo1/")
  signal(error ("Expected to find =E2=80=98/tmp/foo1/./=E2=80=99 in headerl=
ine of /tmp/foo1/"))
  error("Expected to find `%s' in headerline of %s" "/tmp/foo1/./" "/tmp/fo=
o1/")
  dired-rename-subdir-2(("/tmp/foo1/" . #<marker at 1 in foo1>) "/tmp/foo1/=
./" "/tmp/lala1/")
  dired-rename-subdir-1("/tmp/foo1/./" "/tmp/lala1/")
  apply(dired-rename-subdir-1 ("/tmp/foo1/./" "/tmp/lala1/"))
  dired-fun-in-all-buffers("/tmp/foo1/./" nil dired-rename-subdir-1 "/tmp/f=
oo1/./" "/tmp/lala1/")
  dired-rename-subdir("/tmp/foo1/." "/tmp/lala1")
  dired-rename-file("/tmp/foo1/." "/tmp/lala1" nil)
  dired-create-files(dired-rename-file "Move" ("/tmp/foo1/.") #f(compiled-f=
unction (from) #<bytecode 0x156ba85788fd>) t)
  dired-do-create-files(move dired-rename-file "Move" nil t "Rename")
  dired-do-rename(nil)
=20=20
--=20
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#30578; Package emacs. Full text available.
Added tag(s) confirmed. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 22 Feb 2018 17:38:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Feb 22 12:38:41 2018
Received: from localhost ([127.0.0.1]:56784 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eoupN-0004Bs-Gn
	for submit <at> debbugs.gnu.org; Thu, 22 Feb 2018 12:38:41 -0500
Received: from eggs.gnu.org ([208.118.235.92]:45499)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1eoupL-0004Bd-JQ
 for submit <at> debbugs.gnu.org; Thu, 22 Feb 2018 12:38:40 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <drew.adams@HIDDEN>) id 1eoupF-00031u-1P
 for submit <at> debbugs.gnu.org; Thu, 22 Feb 2018 12:38:34 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,T_DKIM_INVALID
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:56406)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <drew.adams@HIDDEN>)
 id 1eoupE-00031m-Tl
 for submit <at> debbugs.gnu.org; Thu, 22 Feb 2018 12:38:32 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:36452)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <drew.adams@HIDDEN>) id 1eoupD-0001Zj-FM
 for bug-gnu-emacs@HIDDEN; Thu, 22 Feb 2018 12:38:32 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <drew.adams@HIDDEN>) id 1eoup9-0002xp-Bv
 for bug-gnu-emacs@HIDDEN; Thu, 22 Feb 2018 12:38:31 -0500
Received: from userp2130.oracle.com ([156.151.31.86]:57992)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <drew.adams@HIDDEN>)
 id 1eoup9-0002vO-0B
 for bug-gnu-emacs@HIDDEN; Thu, 22 Feb 2018 12:38:27 -0500
Received: from pps.filterd (userp2130.oracle.com [127.0.0.1])
 by userp2130.oracle.com (8.16.0.22/8.16.0.22) with SMTP id w1MHbAfo048841
 for <bug-gnu-emacs@HIDDEN>; Thu, 22 Feb 2018 17:38:21 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : subject : content-type :
 content-transfer-encoding; s=corp-2017-10-26;
 bh=jBKGzG+bopdSmRr4SwsbEIQSH0nZO2ZImePWZHgpe4E=;
 b=dXMdRnF8wESg2uPnhVhKngpipWJQqSNQ4RRV3jpio5sik2umpXAbHsa6s4F1Al/0Jt8k
 OUBz6wOpnB/EnlS7pdWVsgja5drGR97yoxiRIvHcejxHLjlvSCWs/lyMuAhZp0qns3lE
 hrAXBMQu90yRz6Vfge21CKp1Lax4JFsLxBcuXhA/FPso216kzN0Y0NHXvObtTql1vmrM
 8R2QfeGcI1Noa3Du1/37MCEnZfePZRH/r5NW/w/S2XhDwH1/yBhspiOI5v7GCLfn1F50
 NCj1mP6513/DO99j1659kp76x16G2yLjD5hDWwb5etAsNSanJOen1lLr7V4NrgZh6phy Xg== 
Received: from userv0022.oracle.com (userv0022.oracle.com [156.151.31.74])
 by userp2130.oracle.com with ESMTP id 2ga1k68b98-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK)
 for <bug-gnu-emacs@HIDDEN>; Thu, 22 Feb 2018 17:38:21 +0000
Received: from aserv0122.oracle.com (aserv0122.oracle.com [141.146.126.236])
 by userv0022.oracle.com (8.14.4/8.14.4) with ESMTP id w1MHcJNI007459
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=FAIL)
 for <bug-gnu-emacs@HIDDEN>; Thu, 22 Feb 2018 17:38:21 GMT
Received: from abhmp0011.oracle.com (abhmp0011.oracle.com [141.146.116.17])
 by aserv0122.oracle.com (8.14.4/8.14.4) with ESMTP id w1MHcJdp028112
 for <bug-gnu-emacs@HIDDEN>; Thu, 22 Feb 2018 17:38:19 GMT
MIME-Version: 1.0
Message-ID: <8629c371-1006-48af-a91f-e147b792abba@default>
Date: Thu, 22 Feb 2018 09:38:17 -0800 (PST)
From: Drew Adams <drew.adams@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 26.0; Dired: moving current directory (./)
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4654.0 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=5900 definitions=8812
 signatures=668677
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 suspectscore=1
 malwarescore=0
 phishscore=0 bulkscore=0 spamscore=0 mlxscore=0 mlxlogscore=834
 adultscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.0.1-1711220000 definitions=main-1802220220
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x [generic] [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

See https://emacs.stackexchange.com/a/39010/105.

Putting point on the current-directory line of a Dired listing, i.e.,
`.', and using `R' to move/rename that directory, works, but you get an
error message, and you don't end up in a Dired listing for that
(now-renamed) directory.

This is the error message you get, where /some/dir1/dir2/ccc/ is the
directory listed in Dired, i.e., the dir that corresponds to `.' in the
Dired listing:

Expected to find /some/dir1/dir2/ccc/./ in headerline of
/some/dir1/dir2/ccc/

It would be good to be able to perform this operation without any
glitches.  (Yes, of course you can always go to the parent directory in
Dired and then rename the child dir from there.)


In GNU Emacs 26.0.91 (build 1, x86_64-w64-mingw32)
 of 2018-01-22
Repository revision: 752fba992b793a74d202c9cfc3e1a92fd458e748
Windowing system distributor `Microsoft Corp.', version 6.1.7601
Configured using:
 `configure --without-dbus --host=3Dx86_64-w64-mingw32
 --without-compress-install 'CFLAGS=3D-O2 -static -g3''




Acknowledgement sent to Drew Adams <drew.adams@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#30578; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 21 Nov 2021 08:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.